Index: /branches/HTM-12.0-dev1/cfg/MV-HEVC/NonCTC/inbl_3view.cfg
===================================================================
--- /branches/HTM-12.0-dev1/cfg/MV-HEVC/NonCTC/inbl_3view.cfg	(revision 1054)
+++ /branches/HTM-12.0-dev1/cfg/MV-HEVC/NonCTC/inbl_3view.cfg	(revision 1054)
@@ -0,0 +1,123 @@
+#=============== fileio ===============
+#InputFile_0            : TREE_0_BASE_LAYER.yuv             # (View 1)
+#InputFile_1            : TREE_1_INDEP_NON_BASE_LAYER.yuv   # (View 4)
+#InputFile_2            : TREE_0_PREDICTED_LAYER_0.yuv      # (View 0)
+#InputFile_3            : TREE_1_PREDICTED_LAYER_0.yuv      # (View 3)
+#InputFile_4            : TREE_0_PREDICTED_LAYER_1.yuv      # (View 2)
+#InputFile_5            : TREE_1_PREDICTED_LAYER_1.yuv      # (View 5)
+#NumberOfLayers         : 6       
+#=============== vps ===============
+ScalabilityMask        : 2        #  Scalability Mask             ( 2: View Scalability, shall be 2 for MV-HEVC )
+DimensionIdLen         : 4        #  Number of bits to store Ids,  per scalability dimension, (m)
+ViewOrderIndex         : 0 1 2 3 4 5    #  ViewOrderIndex, per layer (m)
+LayerIdInNuh           : 0 1 2 3 4 5   #  Layer Id in NAL unit header, (0: no explicit signalling, otherwise per layer ) (m)
+SplittingFlag          : 0        #  Splitting Flag 
+ViewId                 : 1 4 0 3 2 5   #  ViewId, per ViewOrderIndex (m)
+#=============== vpslayersets ===============
+VpsNumLayerSets        : 2           #  Number of layer sets    
+LayerIdsInSet_0        : 0           #  Indices in VPS of layers in layer set 0
+LayerIdsInSet_1        : 0 2 4       #  Indices in VPS of layers in layer set 1
+LayerIdsInSet_2        :             #  Indices in VPS of layers in layer set 2
+LayerIdsInSet_3        :             #  Indices in VPS of layers in layer set 3
+LayerIdsInSet_4        :             #  Indices in VPS of layers in layer set 4
+LayerIdsInSet_5        :             #  Indices in VPS of layers in layer set 5
+LayerIdsInSet_6        :             #  Indices in VPS of layers in layer set 6
+LayerIdsInSet_7        :             #  Indices in VPS of layers in layer set 7
+LayerIdsInSet_8        :             #  Indices in VPS of layers in layer set 8
+
+NumAddLayerSets        : 1           #  Additional layer sets for indpendend decodable non-base layer
+HighestLayerIdxPlus1_0 : -1 3
+
+DefaultTargetOutputLayerIdc : 0         #  Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
+OutputLayerSetIdx           : 1 1 1 1 1 2 2 2 2 2 2 #  Indices of layer sets used to derive additional output layer sets
+# TREE 0 
+LayerIdsInAddOutputLayerSet_0 : 0 2     #  Indices in VPS of output layers in additional output layer set 0
+LayerIdsInAddOutputLayerSet_1 : 0 4     #  Indices in VPS of output layers in additional output layer set 1
+LayerIdsInAddOutputLayerSet_2 : 2 4     #  Indices in VPS of output layers in additional output layer set 2
+LayerIdsInAddOutputLayerSet_3 : 2       #  Indices in VPS of output layers in additional output layer set 3
+LayerIdsInAddOutputLayerSet_4 : 4       #  Indices in VPS of output layers in additional output layer set 4
+# TREE 1
+LayerIdsInAddOutputLayerSet_5 : 1        #  Indices in VPS of output layers in additional output layer set 5
+LayerIdsInAddOutputLayerSet_6 : 1 3      #  Indices in VPS of output layers in additional output layer set 6
+LayerIdsInAddOutputLayerSet_7 : 1 5      #  Indices in VPS of output layers in additional output layer set 7
+LayerIdsInAddOutputLayerSet_8 : 3 5      #  Indices in VPS of output layers in additional output layer set 8
+LayerIdsInAddOutputLayerSet_9 : 3        #  Indices in VPS of output layers in additional output layer set 9
+LayerIdsInAddOutputLayerSet_10: 5        #  Indices in VPS of output layers in additional output layer set 10
+
+ProfileLevelTierIdx    : 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  #  Indices to profile level tier (TBD)
+#=============== vpsdependencies ===============
+DirectRefLayers_1      :          #  Indices in VPS of direct reference layers 
+DirectRefLayers_2      : 0        #  Indices in VPS of direct reference layers 
+DirectRefLayers_3      : 1        #  Indices in VPS of direct reference layers 
+DirectRefLayers_4      : 0        #  Indices in VPS of direct reference layers 
+DirectRefLayers_5      : 3        #  Indices in VPS of direct reference layers 
+
+DependencyTypes_1      :          #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_2      : 2        #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_3      : 2        #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_4      : 2        #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_5      : 2        #  Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+#=============== codingstructure ===============
+IntraPeriod            : 24  #  Period of I-Frame ( -1 = only first)
+DecodingRefreshType    : 1        #  Random Accesss 0:none, 1:CDR, 2:IDR
+GOPSize                : 8        #  GOP Size (number of B slice = GOPSize-1)
+#                           QPfactor      betaOffsetDiv2   #ref_pics_active  reference pictures     deltaRPS     reference idcs          ilPredLayerIdc       refLayerPicPosIl_L1
+#         Type  POC QPoffset     tcOffsetDiv2      temporal_id      #ref_pics                 predict     #ref_idcs        #ActiveRefLayerPics     refLayerPicPosIl_L0   
+Frame1:     B    8     1        0.442    0            0              0           4                4         -8 -10 -12 -16     0                                          0
+Frame2:     B    4     2        0.3536   0            0              0           2                3         -4 -6  4           1       4        5         1 1 0 0 1       0
+Frame3:     B    2     3        0.3536   0            0              0           2                4         -2 -4  2 6         1       2        4         1 1 1 1         0
+Frame4:     B    1     4        0.68     0            0              0           2                4         -1  1  3 7         1       1        5         1 0 1 1 1       0
+Frame5:     B    3     4        0.68     0            0              0           2                4         -1 -3  1 5         1      -2        5         1 1 1 1 0       0
+Frame6:     B    6     3        0.3536   0            0              0           2                4         -2 -4 -6 2         1      -3        5         1 1 1 1 0       0
+Frame7:     B    5     4        0.68     0            0              0           2                4         -1 -5  1 3         1       1        5         1 0 1 1 1       0
+Frame8:     B    7     4        0.68     0            0              0           2                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       0
+    
+FrameI_l1:  I    0     0        0.442    0            0              0           0                0                            0                                          0             
+Frame1_l1:  B    8     1        0.442    0            0              0           4                4         -8 -10 -12 -16     0                                          0             
+Frame2_l1:  B    4     2        0.3536   0            0              0           2                3         -4 -6  4           1       4        5         1 1 0 0 1       0             
+Frame3_l1:  B    2     3        0.3536   0            0              0           2                4         -2 -4  2 6         1       2        4         1 1 1 1         0             
+Frame4_l1:  B    1     4        0.68     0            0              0           2                4         -1  1  3 7         1       1        5         1 0 1 1 1       0             
+Frame5_l1:  B    3     4        0.68     0            0              0           2                4         -1 -3  1 5         1      -2        5         1 1 1 1 0       0             
+Frame6_l1:  B    6     3        0.3536   0            0              0           2                4         -2 -4 -6 2         1      -3        5         1 1 1 1 0       0             
+Frame7_l1:  B    5     4        0.68     0            0              0           2                4         -1 -5  1 3         1       1        5         1 0 1 1 1       0             
+Frame8_l1:  B    7     4        0.68     0            0              0           2                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       0             
+
+FrameI_l2:  P    0     3     0.442    0        0        0        1      0                        0                                 1            0         0          -1    
+Frame1_l2:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 1            0         1          -1    
+Frame2_l2:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       1            0         1          -1    
+Frame3_l2:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         1            0         1          -1    
+Frame4_l2:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       1            0         1          -1    
+Frame5_l2:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       1            0         2          -1    
+Frame6_l2:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       1            0         2          -1    
+Frame7_l2:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       1            0         2          -1    
+Frame8_l2:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       1            0         2          -1    
+
+FrameI_l3:  P    0     3     0.442    0        0        0        1      0                        0                                 1            0         0          -1    
+Frame1_l3:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 1            0         1          -1    
+Frame2_l3:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       1            0         1          -1    
+Frame3_l3:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         1            0         1          -1    
+Frame4_l3:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       1            0         1          -1    
+Frame5_l3:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       1            0         2          -1    
+Frame6_l3:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       1            0         2          -1    
+Frame7_l3:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       1            0         2          -1    
+Frame8_l3:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       1            0         2          -1    
+
+FrameI_l4:  P    0     3     0.442    0        0        0        1      0                        0                                 1            0         0          -1    
+Frame1_l4:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 1            0         1          -1    
+Frame2_l4:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       1            0         1          -1    
+Frame3_l4:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         1            0         1          -1    
+Frame4_l4:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       1            0         1          -1    
+Frame5_l4:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       1            0         2          -1    
+Frame6_l4:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       1            0         2          -1    
+Frame7_l4:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       1            0         2          -1    
+Frame8_l4:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       1            0         2          -1    
+
+FrameI_l5:  P    0     3     0.442    0        0        0        1      0                        0                                 1            0         0          -1    
+Frame1_l5:  B    8     4     0.442    0        0        0        4      4     -8 -10 -12 -16     0                                 1            0         1          -1    
+Frame2_l5:  B    4     5     0.3536   0        0        0        3      3     -4 -6  4           1     4     5     1 1 0 0 1       1            0         1          -1    
+Frame3_l5:  B    2     6     0.3536   0        0        0        3      4     -2 -4  2 6         1     2     4     1 1 1 1         1            0         1          -1    
+Frame4_l5:  B    1     7     0.68     0        0        0        3      4     -1  1  3 7         1     1     5     1 0 1 1 1       1            0         1          -1    
+Frame5_l5:  B    3     7     0.68     0        0        0        3      4     -1 -3  1 5         1    -2     5     1 1 1 1 0       1            0         2          -1    
+Frame6_l5:  B    6     6     0.3536   0        0        0        3      4     -2 -4 -6 2         1    -3     5     1 1 1 1 0       1            0         2          -1    
+Frame7_l5:  B    5     7     0.68     0        0        0        3      4     -1 -5  1 3         1     1     5     1 0 1 1 1       1            0         2          -1    
+Frame8_l5:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0       1            0         2          -1    
Index: /branches/HTM-12.0-dev1/cfg/MV-HEVC/baseCfg_3view.cfg
===================================================================
--- /branches/HTM-12.0-dev1/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 1053)
+++ /branches/HTM-12.0-dev1/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 1054)
@@ -8,4 +8,7 @@
 InputFile_1                   : newspapercc_2.yuv                               
 InputFile_2                   : newspapercc_6.yuv                              
+InputFile_3                   :                               
+InputFile_4                   :                                
+InputFile_5                   :       
 
 BitstreamFile                 : stream.bit                         
@@ -14,4 +17,7 @@
 ReconFile_1                   : rec_2.yuv                         
 ReconFile_2                   : rec_6.yuv                           
+ReconFile_3                   :                           
+ReconFile_4                   :                          
+ReconFile_5                   :                            
 
 NumberOfLayers                : 3           # number of layers to be coded
@@ -22,4 +28,5 @@
 ViewOrderIndex                : 0 1 2       # ViewOrderIndex, per layer (m)
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling, otherwise per layer ) (m)
+TargetEncLayerIdList          :             # Layer Id in Nuh to be encoded, (empty:-> all layers will be encode) 
 SplittingFlag                 : 0           # Splitting Flag 
 ViewId                        : 1 0 2       # ViewId, per ViewOrderIndex (m)
@@ -34,5 +41,13 @@
 LayerIdsInSet_5               : 
 LayerIdsInSet_6               : 
-
+LayerIdsInSet_7               : 
+LayerIdsInSet_8               : 
+LayerIdsInSet_9               : 
+LayerIdsInSet_10              : 
+
+NumAddLayerSets               : 0            # Specifies the number of additional layer sets
+HighestLayerIdxPlus1_0        : -1           # Highest layer idx plus 1 for the 0-th additonal layer set, per independent layer (m) (first value will be ignored)
+HighestLayerIdxPlus1_1        : -1           # Highest layer idx plus 1 for the 1-th additonal layer set, per independent layer (m) (first value will be ignored)
+HighestLayerIdxPlus1_2        : -1           # Highest layer idx plus 1 for the 2-th additonal layer set, per independent layer (m) (first value will be ignored)
 
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
@@ -41,15 +56,28 @@
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
-LayerIdsInAddOutputLayerSet_2 :              # Indices in VPS of output layers in additional output layer set 1
-LayerIdsInAddOutputLayerSet_3 :              # Indices in VPS of output layers in additional output layer set 1
-LayerIdsInAddOutputLayerSet_4 :              # Indices in VPS of output layers in additional output layer set 1
-
-ProfileLevelTierIdx           : 0 0 0 0 0 0  # Indices to profile level tier (TBD)
+LayerIdsInAddOutputLayerSet_2 :              # Indices in VPS of output layers in additional output layer set 2
+LayerIdsInAddOutputLayerSet_3 :              # Indices in VPS of output layers in additional output layer set 3
+LayerIdsInAddOutputLayerSet_4 :              # Indices in VPS of output layers in additional output layer set 4
+LayerIdsInAddOutputLayerSet_5 :              # Indices in VPS of output layers in additional output layer set 5
+LayerIdsInAddOutputLayerSet_6 :              # Indices in VPS of output layers in additional output layer set 6
+LayerIdsInAddOutputLayerSet_7 :              # Indices in VPS of output layers in additional output layer set 7
+LayerIdsInAddOutputLayerSet_8 :              # Indices in VPS of output layers in additional output layer set 8
+LayerIdsInAddOutputLayerSet_9 :              # Indices in VPS of output layers in additional output layer set 9
+LayerIdsInAddOutputLayerSet_10:              # Indices in VPS of output layers in additional output layer set 10
+
+ProfileLevelTierIdx           : 0 0 0 0 0 0 0 0 0 0 0 0 0 0  # Indices to profile level tier (TBD)
 
 #======== VPS / Dependencies ================
 DirectRefLayers_1             : 0           # Indices in VPS of direct reference layers 
 DirectRefLayers_2             : 0           # Indices in VPS of direct reference layers 
+DirectRefLayers_3             :             # Indices in VPS of direct reference layers 
+DirectRefLayers_4             :             # Indices in VPS of direct reference layers 
+DirectRefLayers_5             :             # Indices in VPS of direct reference layers 
+
 DependencyTypes_1             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
 DependencyTypes_2             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_3             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_4             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
+DependencyTypes_5             : 2           # Dependency types of direct reference layers, 0: Sample 1: Motion 2: Sample+Motion
 
 #======== Unit definition ================
@@ -101,4 +129,34 @@
 Frame8_l2:  B    7     7     0.68     0        0        0        3      4     -1 -3 -7 1         1    -2     5     1 1 1 1 0         1          0         2          -1        
 
+FrameI_l3:
+Frame1_l3:
+Frame2_l3:
+Frame3_l3:
+Frame4_l3:
+Frame5_l3:
+Frame6_l3:
+Frame7_l3:
+Frame8_l3:
+    
+FrameI_l4:
+Frame1_l4:
+Frame2_l4:
+Frame3_l4:
+Frame4_l4:
+Frame5_l4:
+Frame6_l4:
+Frame7_l4:
+Frame8_l4:
+
+FrameI_l5:
+Frame1_l5:
+Frame2_l5:
+Frame3_l5:
+Frame4_l5:
+Frame5_l5:
+Frame6_l5:
+Frame7_l5:
+Frame8_l5:
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
Index: /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1053)
+++ /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1054)
@@ -94,4 +94,9 @@
   ("TarDecLayerIdSetFile,l", cfg_TargetDecLayerIdSetFile, string(""), "targetDecLayerIdSet file name. The file should include white space separated LayerId values to be decoded. Omitting the option or a value of -1 in the file decodes all layers.")
   ("RespectDefDispWindow,w", m_respectDefDispWindow, 0, "Only output content inside the default display window\n")
+#if H_MV
+#if H_MV_HLS10_GEN_FIX
+  ("OutputVpsInfo,v", m_outputVpsInfo, false, "Output information about the layer dependencies and layer sets")
+#endif
+#endif
   ;
   po::setDefaults(opts);
Index: /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.h	(revision 1053)
+++ /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecCfg.h	(revision 1054)
@@ -80,4 +80,7 @@
 
 #if H_MV
+#if H_MV_HLS10_GEN_FIX
+  Bool          m_outputVpsInfo;                     ///< Output VPS information 
+#endif
   Void xAppendToFileNameEnd( Char* pchInputFileName, const Char* pchStringToAppend, Char*& rpchOutputFileName); ///< create filenames
 #endif
Index: /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1053)
+++ /branches/HTM-12.0-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1054)
@@ -239,23 +239,31 @@
           {
             TComVPS* vps = m_vps; 
-          if ( m_targetOptLayerSetIdx == -1 )
+            if ( m_targetOptLayerSetIdx == -1 )
+            {
+              // Not normative! Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
+              m_targetOptLayerSetIdx = vps->getVpsNumLayerSetsMinus1(); 
+            }
+
+            for (Int dI = 0; dI < m_numDecoders; dI++ )
+            {
+              m_tDecTop[decIdx]->setTargetOptLayerSetIdx( m_targetOptLayerSetIdx ); 
+            }
+
+            if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= vps->getNumOutputLayerSets() )
+            {
+              fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", vps->getNumOutputLayerSets() - 1 );            
+              exit(EXIT_FAILURE);
+            }
+            m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
+          }
+#if H_MV_HLS10_GEN_FIX
+          if (m_outputVpsInfo )
           {
-            // Not normative! Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
-            m_targetOptLayerSetIdx = vps->getVpsNumLayerSetsMinus1(); 
+            m_vps->printLayerDependencies();
+            m_vps->printLayerSets();
+            m_vps->printPTL(); 
           }
-
-          for (Int dI = 0; dI < m_numDecoders; dI++ )
-          {
-            m_tDecTop[decIdx]->setTargetOptLayerSetIdx( m_targetOptLayerSetIdx ); 
-          }
-
-          if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= vps->getNumOutputLayerSets() )
-          {
-            fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", vps->getNumOutputLayerSets() - 1 );            
-            exit(EXIT_FAILURE);
-          }
-          m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
-        }
-      }
+#endif
+        }
 #if H_3D
         if (nalu.m_nalUnitType == NAL_UNIT_VPS )
@@ -569,6 +577,10 @@
   Int dpbFullness = 0;
 #if H_MV
+#if H_MV_HLS10_ADD_LAYERSETS
+  TComSPS* activeSPS = m_tDecTop[ decIdx ]->getActiveSPS();
+#else
   // preliminary fix
   TComSPS* activeSPS = m_tDecTop[0]->getActiveSPS();
+#endif
 #else
   TComSPS* activeSPS = m_cTDecTop.getActiveSPS();
